/******************************************************************************
 *                               IOM Compiler                                 *
 *       _                               _ _                                  *
 *      (_)___ _ __    __ ___ _ __  _ __(_) |___ _ _                          *
 *      | / _ \ '  \  / _/ _ \ '  \| '_ \ | / -_) '_|                         *
 *      |_\___/_|_|_| \__\___/_|_|_| .__/_|_\___|_|                           *
 *                                 |_|                                        *
 *                                                                            *
 * Copyright (c) 2018, Andreas Schwenk, contact@compiler-construction.com     *
 *                                                                            *
 * GNU GENERAL PUBLIC LICENSE Version 3, 29 June 2007                         *
 *                                                                            *
 * This library is licensed as described in LICENSE, which you should have    *
 * received as part of this distribution.                                     *
 *                                                                            *
 * This software is distributed on "AS IS" basis, WITHOUT WARRENTY OF ANY     *
 * KIND, either impressed or implied.                                         *
 ******************************************************************************/

#include "stdio.h"

#include "config.h"

#include "6-mcg-iomcpu.h"

#define IOMCPU_MNEMONIC__LIST_SIZE 64
#define IOMCPU_MNEMONIC__STR_SIZE 32

char IOMCPU_Mnemonic_List
    [IOMCPU_MNEMONIC__LIST_SIZE][IOMCPU_MNEMONIC__STR_SIZE] = {

        /*  0-15: instruction type A */
        "IOMCPU_SHUTDOWN" /* 0 --------------------------------------------- */,
        "IOMCPU_NO_OP" /* 1 ------------------------------------------------ */,
        "IOMCPU_JUMP" /* 2 ------------------------------------------------- */,
        "IOMCPU_CALL" /* 3 ------------------------------------------------- */,
        "IOMCPU_RETURN" /* 4 ----------------------------------------------- */,
        "" /* 5 ------------------------------------------------------------ */,
        "" /* 6 ------------------------------------------------------------ */,
        "" /* 7 ------------------------------------------------------------ */,
        "" /* 8 ------------------------------------------------------------ */,
        "" /* 9 ------------------------------------------------------------ */,
        "" /* 10 ----------------------------------------------------------- */,
        "" /* 11 ----------------------------------------------------------- */,
        "" /* 12 ----------------------------------------------------------- */,
        "" /* 13 ----------------------------------------------------------- */,
        "" /* 14 ----------------------------------------------------------- */,
        "" /* 15 ----------------------------------------------------------- */,

        /* 16-31: instruction type B */
        "IOMCPU_LOAD" /* 16 ------------------------------------------------ */,
        "IOMCPU_STORE" /* 17 ----------------------------------------------- */,
        "IOMCPU_LOAD_UPPER_IMM" /* 18 -------------------------------------- */,
        "IOMCPU_LOAD_IMMEDIATE" /* 19 ---------------------------------------*/,
        "IOMCPU_OPC_RETURN_WITH_VALUE" /* 20 ------------------------------- */,
        "" /* 21 ----------------------------------------------------------- */,
        "" /* 22 ----------------------------------------------------------- */,
        "" /* 23 ----------------------------------------------------------- */,
        "" /* 24 ----------------------------------------------------------- */,
        "" /* 25 ----------------------------------------------------------- */,
        "" /* 26 ----------------------------------------------------------- */,
        "" /* 27 ----------------------------------------------------------- */,
        "" /* 28 ----------------------------------------------------------- */,
        "" /* 29 ----------------------------------------------------------- */,
        "" /* 30 ----------------------------------------------------------- */,
        "" /* 31 ----------------------------------------------------------- */,

        /* 32-47: instruction type C */
        "IOMCPU_MOVE" /* 32 ------------------------------------------------ */,
        "IOMCPU_LOAD_IND" /* 33 -------------------------------------------- */,
        "IOMCPU_STORE_IND" /* 34 ------------------------------------------- */,
        "" /* 35 ----------------------------------------------------------- */,
        "" /* 36 ----------------------------------------------------------- */,
        "" /* 37 ----------------------------------------------------------- */,
        "" /* 38 ----------------------------------------------------------- */,
        "" /* 39 ----------------------------------------------------------- */,
        "" /* 40 ----------------------------------------------------------- */,
        "" /* 41 ----------------------------------------------------------- */,
        "" /* 42 ----------------------------------------------------------- */,
        "" /* 43 ----------------------------------------------------------- */,
        "" /* 44 ----------------------------------------------------------- */,
        "" /* 45 ----------------------------------------------------------- */,
        "" /* 46 ----------------------------------------------------------- */,
        "" /* 47 ----------------------------------------------------------- */,

        /* 48-63: instruction type D */
        "IOMCPU_ADD" /* 48 ------------------------------------------------- */,
        "IOMCPU_SUB" /* 49 ------------------------------------------------- */,
        "IOMCPU_MUL" /* 50 ------------------------------------------------- */,
        "IOMCPU_DIV" /* 51 ------------------------------------------------- */,
        "IOMCPU_OPC_CMP" /* 52 --------------------------------------------- */,
        "IOMCPU_FLOAT_ADD" /* 53 ------------------------------------------- */,
        "IOMCPU_FLOAT_SUB" /* 54 ------------------------------------------- */,
        "IOMCPU_FLOAT_MUL" /* 55 ------------------------------------------- */,
        "IOMCPU_FLOAT_DIV" /* 56 ------------------------------------------- */,
        "" /* 57 ----------------------------------------------------------- */,
        "" /* 58 ----------------------------------------------------------- */,
        "" /* 59 ----------------------------------------------------------- */,
        "" /* 60 ----------------------------------------------------------- */,
        "" /* 61 ----------------------------------------------------------- */,
        "" /* 62 ----------------------------------------------------------- */,
        "" /* 63 ----------------------------------------------------------- */
};

char *get_iomcpu_mnemonic_name(enum IOMCPU_Opcode opcode) {
  return IOMCPU_Mnemonic_List[opcode];
}

#define PRINT_INDENT(N)                                                        \
  {                                                                            \
    for (int i = 0; i < (N); i++)                                              \
      printf("    ");                                                          \
  }

void print_mc_instruction(struct IOMCPU_Instruction *instr, int indent) {
  PRINT_INDENT(indent);
  switch (instr->opcode >> 4) {
  case 0: /* instruction type A */
    printf("$%08llu %s %lld\n", instr->address,
           get_iomcpu_mnemonic_name(instr->opcode), instr->op[0]);
    break;
  case 1: /* instruction type B */
    printf("$%08llu %s %lld %lld\n", instr->address,
           get_iomcpu_mnemonic_name(instr->opcode), instr->op[0], instr->op[1]);
    break;
  case 2: /* instruction type C */
    printf("$%08llu %s %lld %lld %lld\n", instr->address,
           get_iomcpu_mnemonic_name(instr->opcode), instr->op[0], instr->op[1],
           instr->op[2]);
    break;
  case 3: /* instruction type D */
    printf("$%08llu %s %lld %lld %lld\n", instr->address,
           get_iomcpu_mnemonic_name(instr->opcode), instr->op[0], instr->op[1],
           instr->op[2]);
    break;
  default:
    assert(false);
  }
}

void print_machine_code__iom_cpu(struct Symbol *sym, int indent) {
  /* for all basic blocks */
  struct mate__List_iterator basicblock_iterator =
      mate__create_list_iterator(sym->code_basicblocks);
  struct Basicblock *bb;
  while ((bb = mate__get_next_list_iterator_item(&basicblock_iterator)) !=
         NULL) {
    /* for all instructions*/
    struct mate__List_iterator mc_iterator =
        mate__create_list_iterator(bb->machine_code);
    struct IOMCPU_Instruction *mc_instr;
    while ((mc_instr = mate__get_next_list_iterator_item(&mc_iterator)) !=
           NULL) {
      print_mc_instruction(mc_instr, indent);
    }
    PRINT_INDENT(indent);
    printf("***\n");
  }
}
